# The model has already been created by the framework, and extends Rhom::RhomObject
# You can add more methods here
class Component
  include Rhom::FixedSchema

  property :key, :string
  property :value, :string

  set :schema_version, "1.0"

  # Uncomment the following line to enable sync with Roster.
  # enable :sync

  #add model specifc code here

  class << self
    def find_by_key(key)
      if re = Component.find(:first, :conditions => {"key" => key})
        return re
      end
    end
    alias :fbk find_by_key

    def value_by_key(key)
      if re = Component.fbk(key)
        return re.value
      else
        return ""
      end
    end
    alias :vbk value_by_key

    def save_by_key(key, value)
      if re = Component.fbk(key)
        re.update_attributes(key => value)
      else
        Component.create("key" => key, "value" => value)
      end
    end
    alias :sbk save_by_key

    def server_address
      Component.vbk("server_address")
    end
    alias :sa server_address
  end
  
end
