# The model has already been created by the framework, and extends Rhom::RhomObject
# You can add more methods here
require 'json'
class Roster
  include Rhom::FixedSchema

  property :id, :integer
  property :username, :string
  property :company_name, :string
  property :address, :string
  property :phone_number, :string
  property :update_flg, :integer
  property :delete_flg, :integer

  FALSE = 0
  TRUE = 1

  set :schema_version, "1.0"
  # Uncomment the following line to enable sync with Roster.
  # enable :sync

  #add model specifc code here

  # 同期処理
  def self.sync
    # クライアントで作成したデータと、変更したデータを取得
    rosters = Roster.find(:all, :conditions => {"id" => nil})
    rosters += Roster.find(:all, :conditions => {"update_flg" => TRUE})
    rosters += Roster.find(:all, :conditions => {"delete_flg" => TRUE})

    json = JSON.generate(rosters.map{|r|r.as_json})
    http = Rho::AsyncHttp.post(
      :url => "#{Component.sa}/rosters/sync.json",
      :body => "json=#{json}"
    )

    if http["status"] == "ok"
      body = http["body"]
      if body["status"] == "OK"
        Roster.delete_all
        body["results"].each do |r|
          Roster.create(r.merge(:update_flg => FALSE, :delete_flg => FALSE))
        end
        return true
      end
      Alert.show_popup(body["msg"])
    else
      Alert.show_popup("サーバに接続できませんでした。")
    end
  end

  def as_json
    attr = {
      :username => self.username,
      :company_name => self.company_name,
      :address => self.address,
      :phone_number => self.phone_number,
      :delete_flg => self.delete_flg
    }
    attr.merge!(:id => self.id) if self.id
    return attr
  end
end
