require 'rho/rhocontroller'
require 'helpers/browser_helper'

class RosterController < Rho::RhoController
  include BrowserHelper

  # GET /Roster
  def index
    @rosters = Roster.find(:all, :conditions => {"delete_flg" => Roster::FALSE})
    render :back => '/app'
  end

  def sync
    Roster.sync
    redirect Rho::RhoConfig.start_path
  end

  # GET /Roster/{1}
  def show
    @roster = Roster.find(@params['id'])
    if @roster
      render :action => :show, :back => url_for(:action => :index)
    else
      redirect :action => :index
    end
  end

  # GET /Roster/new
  def new
    @roster = Roster.new
    render :action => :new, :back => url_for(:action => :index)
  end

  # GET /Roster/{1}/edit
  def edit
    @roster = Roster.find(@params['id'])
    if @roster
      render :action => :edit, :back => url_for(:action => :index)
    else
      redirect :action => :index
    end
  end

  # POST /Roster/create
  def create
    attr = @params['roster']
    @roster = Roster.create(attr.merge("delete_flg" => Roster::FALSE))
    redirect :action => :index
  end

  # POST /Roster/{1}/update
  def update
    @roster = Roster.find(@params['id'])
    attr = @params['roster'].merge("update_flg" => Roster::TRUE)
    @roster.update_attributes(attr) if @roster
    redirect :action => :index
  end

  # POST /Roster/{1}/delete
  def delete
    @roster = Roster.find(@params['id'])
    if @roster.id.nil?
     @roster.destroy
    else
      @roster.update_attributes("delete_flg" => Roster::TRUE)
    end
    redirect :action => :index  
  end
end
