require 'rho/rhocontroller'
require 'helpers/browser_helper'
require 'json'

class RosterJsonController < Rho::RhoController
  include BrowserHelper

  # GET /RosterJson
  def index
    http = Rho::AsyncHttp.get(:url => "#{Component.sa}/rosters.json")
    @rosterjsons = http["body"].map{|b|RosterJson.new(b)}
    render :back => '/app'
  end

  # GET /RosterJson/{1}
  def show
    id = strip_braces(@params['id'])
    http = Rho::AsyncHttp.get(:url => "#{Component.sa}/rosters/#{id}.json")
    @rosterjson = RosterJson.new(http["body"])
    if @rosterjson
      render :action => :show, :back => url_for(:action => :index)
    else
      redirect :action => :index
    end
  end

  # GET /RosterJson/new
  def new
    @rosterjson = RosterJson.new
    render :action => :new, :back => url_for(:action => :index)
  end

  # GET /RosterJson/{1}/edit
  def edit
    id = strip_braces(@params['id'])
    http = Rho::AsyncHttp.get(:url => "#{Component.sa}/rosters/#{id}.json")
    @rosterjson = RosterJson.new(http["body"])
    if @rosterjson
      render :action => :edit, :back => url_for(:action => :index)
    else
      redirect :action => :index
    end
  end

  # POST /RosterJson/create
  def create
    json = JSON.generate(@params['rosterjson'])
    Rho::AsyncHttp.post(
      :url => "#{Component.sa}/rosters.json",
      :body => "json=#{json}",
      :callback => url_for(:action => :save_callback)
    )
    render :string => "Wait..."
  end

  def save_callback
    if @params["status"] == "ok"
      body = @params["body"]
      Alert.show_popup(body["msg"])
    else
      Alert.show_popup("サーバに接続できませんでした。")
    end
    WebView.navigate(url_for(:action => :index))
  end

  # POST /RosterJson/{1}/update
  def update
    id = strip_braces(@params['id'])
    json = JSON.generate(@params['rosterjson'])
    Rho::AsyncHttp.post(
      :url => "#{Component.sa}/rosters/#{id}.json",
      :body => "json=#{json}",
      :callback => url_for(:action => :save_callback),
      :http_command => "PUT"
    )
    render :string => "Wait..."
  end

  # POST /RosterJson/{1}/delete
  def delete
    id = strip_braces(@params['id'])
    json = JSON.generate(@params['rosterjson'])
    Rho::AsyncHttp.post(
      :url => "#{Component.sa}/rosters/#{id}.json",
      :body => "json=#{json}",
      :callback => url_for(:action => :save_callback),
      :http_command => "DELETE"
    )
    render :string => "Wait..."
  end
end
